-- Trench Gun script by Cyber
-- Based on minigun script by Tuxedo Labs

function init()
	RegisterTool("Trench", "Trench", "MOD/vox/Trench.vox")
	SetBool("game.tool.Trench.enabled", true)
	SetFloat("game.tool.Trench.ammo", 7)
	unlimitedammo = GetBool("savegame.mod.unlimitedammo")
	incendiaryammo = GetBool("savegame.mod.incendiaryammo")
	norecoil = GetBool("savegame.mod.norecoil")
	
	angle = 0
	mode = 0
	ModeWait = 0
	angVel = 0
	coolDown = 0
	smoke = 0
	magammo = 6
	relTime = 0
	reloading = 0
	opensound = 0
	closesound = 0
	scopesound = 0
	needpull = 0
	needclose = 0
	relfromzero = 0
	relzero = 0
	modes = "OO BUCK"
	
	gunSnd = LoadSound("MOD/snd/gunsnd.ogg")
	gunRel = LoadSound("MOD/snd/reload.ogg")
	gunBoltopen = LoadSound("MOD/snd/boltopen.ogg")
	gunBoltclose = LoadSound("MOD/snd/boltclose.ogg")
	shellSnd = LoadSound("MOD/snd/Shellsnd.ogg")
	
	oldPipePos = Vec()
	particleTimer = 0
end

function rndVec(length)
	local v = VecNormalize(Vec(math.random(-100,100), math.random(-100,100), math.random(-100,100)))
	return VecScale(v, length)	
end

function rnd(mi, ma)
	return math.random(1000)/1000*(ma-mi) + mi
end

function tick(dt)

	if GetString("game.player.tool") == "Trench" then

		local ct = GetCameraTransform()
        
		pumpAction()
		ChangeMode()
		reload()
		pull()
		relTime = relTime - dt
		ModeWait = ModeWait - dt
		
		if needpull == 2 then
			local b = GetToolBody()
			local shapes = GetBodyShapes(b)
			
			if b ~= body then
				body = b
				t0 = GetShapeLocalTransform(shapes[1])
			end

			t = TransformCopy(t0)
			t.pos = VecAdd(t.pos, Vec(0,0,0.3))
			SetShapeLocalTransform(shapes[1], t)	
		end
		
		if needpull == 0 then
			local b = GetToolBody()
			local shapes = GetBodyShapes(b)
		
			if b ~= body then
				body = b
				t0 = GetShapeLocalTransform(shapes[1])
			end

			t = TransformCopy(t0)
			t.pos = VecAdd(t.pos, Vec(0,0,0))
			SetShapeLocalTransform(shapes[1], t)				
		end
		
	if GetBool("game.player.canusetool") and InputDown("usetool") and magammo > 0 and reloading == 0 and needpull == 0 and needclose == 0 then
		if coolDown < 0 and needclose == 0 then
			local t = GetCameraTransform()
			local fwd = TransformToParentVec(t, Vec(0, 0, -1))
			local maxDist = 1500
			local hit, dist, normal, shape = QueryRaycast(t.pos, fwd, maxDist)
			if not hit then
				dist = maxDist
			end
			if mode == 0 then
				for i=0, 8 do
					local s = VecAdd(VecAdd(t.pos, Vec(0, -0.5, 0)),VecScale(fwd, 1.5))
					local e = VecAdd(t.pos, VecScale(fwd, dist))
					local p = TransformToParentPoint(ct, Vec(0.15, -.15, -1.4))
					local d = VecAdd(TransformToParentVec(ct, Vec(0,0,-1)), rndVec(0.03))
					Shoot(p, d, "gun")
				end
			end
			if mode == 1 then
				for i=0, 16 do
					local s = VecAdd(VecAdd(t.pos, Vec(0, -0.5, 0)),VecScale(fwd, 1.5))
					local e = VecAdd(t.pos, VecScale(fwd, dist))
					local p = TransformToParentPoint(ct, Vec(0.15, 0, -1.4))
					local d = VecAdd(TransformToParentVec(ct, Vec(0,0,-1)), rndVec(0.00))
					Shoot(p, d, "gun")
				end
			end
			if mode == 2 then
				for i=0, 8 do
					local s = VecAdd(VecAdd(t.pos, Vec(0, -0.5, 0)),VecScale(fwd, 1.5))
					local e = VecAdd(t.pos, VecScale(fwd, dist))
					local p = TransformToParentPoint(ct, Vec(0.15, -.15, -1.4))
					local d = VecAdd(TransformToParentVec(ct, Vec(0,0,-1)), rndVec(0.04))
					if hit then
						Explosion(e, 0.5)
						SpawnParticle("smoke", e, rndVec(0.5), 1.0, 1.0)
					end
				end
			end
			if mode == 3 then
				for i=0, 8 do
					local s = VecAdd(VecAdd(t.pos, Vec(0, -0.5, 0)),VecScale(fwd, 1.5))
					local e = VecAdd(t.pos, VecScale(fwd, dist))
					local p = TransformToParentPoint(ct, Vec(0.15, -.15, -1.4))
					local d = VecAdd(TransformToParentVec(ct, Vec(0,0,-1)), rndVec(0.03))
					Shoot(p, d)
				end
			end
			if mode == 4 then
				for i=0, 8 do
					local s = VecAdd(VecAdd(t.pos, Vec(0, -0.5, 0)),VecScale(fwd, 1.5))
					local e = VecAdd(t.pos, VecScale(fwd, dist))
					local p = TransformToParentPoint(ct, Vec(0.15, -.15, -1.4))
					local d = VecAdd(TransformToParentVec(ct, Vec(0,0,-1)), rndVec(0.03))
					Shoot(p, d, "rocket", 1.0)
				end
			end
			if mode == 5 then
					local s = VecAdd(VecAdd(t.pos, Vec(0, -0.5, 0)),VecScale(fwd, 1.5))
					local e = VecAdd(t.pos, VecScale(fwd, dist))
					local p = TransformToParentPoint(ct, Vec(0.15, -.15, -1.4))
					local d = VecAdd(TransformToParentVec(ct, Vec(0,0,-1)), rndVec(0.03))
					if hit then
						Explosion(e, 4.0)
						ParticleGravity(4)
						ParticleRotation(.2)
						ParticleRadius(4.0)
						ParticleType("plain")
						ParticleCollide(0)
						ParticleDrag(1)
						ParticleColor(.5,.5,.5)
						r = VecAdd (e, Vec(8, 0, 0))
						SpawnParticle(r, VecAdd(0,0,0), 5.0)
						r = VecAdd (e, Vec(0, 0, 8))
						SpawnParticle(r, VecAdd(0,0,0), 5.0)
						ParticleRotation(-.2)
						r = VecAdd (e, Vec(-8, 0, 0))
						SpawnParticle(r, VecAdd(0,0,0), 5.0)
						r = VecAdd (e, Vec(0, 0, -8))
						SpawnParticle(r, VecAdd(0,0,0), 5.0)
						r = VecAdd (e, Vec(0, 0, 0))
						SpawnParticle(r, VecAdd(0,0,0), 5.0)
						ParticleRadius(1.0, 100.0)
						r = VecAdd (e, Vec(0, 5, 0))
						SpawnParticle(r, VecAdd(0,0,0), 5.0)
					end					
			end
	
			if not norecoil then
				local g = Vec(0, -5, 0)
				SetPlayerVelocity(g)
			end

			local lp = TransformToParentPoint(ct, Vec(0.25, -0.25, -2.0))
			PointLight(lp, 1, 0.7, 0.5, 3)
			PlaySound(gunSnd)	                
		

			smoke = math.min(1.0, smoke + .5)
			coolDown = .2
			if not unlimitedammo then
				magammo = magammo - 1
			end
			needpull = 1
			needclose = 1
		end
end
		local p = TransformToParentPoint(ct, Vec(0.3, -0.15, -1.9))
		if not InputDown("lmb") then
			if smoke > 0 then
				if particleTimer < 0.0 then
					particleTimer = dt + (1.0-smoke)*0.05
					local vel = VecScale(VecSub(p, oldPipePos), 0.5/ dt)
					vel = VecAdd(vel, Vec(0, rnd(0, 2), 0))
					ParticleType("smoke")
					ParticleRadius(0.08, 0.15)
					ParticleAlpha(smoke*0.4, 0)
					ParticleDrag(15)
					SpawnParticle(p, VecAdd(vel, rndVec(0.1)), 2.0)					
				end	
			end			
        end
		particleTimer = particleTimer - dt
		oldPipePos = p
	
		coolDown = coolDown - dt
		angle = angle + angVel*dt
		
		local t = Transform()
		local recoil = math.max(-.2, coolDown)
		t.pos = Vec(0.5, .1, recoil)
		SetToolTransform(t)
	end
	smoke = math.max(0.0, smoke - dt/3)	
end

function pull()
	if not InputDown("rmb") and reloading == 0 then
		if needpull == 2 then
			needclose = 2
		end
		if needclose == 3 then
			needclose = 0 
			needpull = 0
			opensound = 0
			closesound = 0
			PlaySound(gunBoltclose)
		end
	end
end


function draw()
	if GetString("game.player.tool") == "Trench" and GetPlayerVehicle() == 0 then
		UiPush()			
			UiTranslate(UiCenter(), UiHeight()-60)
			UiAlign("center middle")
			UiColor(1, 1, 1)
			UiFont("bold.ttf", 32)
			UiTextOutline(0,0,0,1,0.1)
			if reloading == 0 and needpull == 0 then
			    UiText(magammo.." : "..modes)
				else if reloading == 1 then
			    UiText("RELOADING".." "..(math.floor(relTime * 10) /10))
				else if needpull > 0 then
			    UiText("RMB")
				end
				end
			end	
			if mode == 0 then
				 modes = "00 BUCK" 
			else if mode == 1 then
				modes = "SLUG"
			else if mode == 2 then
				modes = "FRAG"
            else if mode == 3 then
				modes = "MAGNUM"
			else if mode == 4 then
				modes = "MISSILE"	
			else if mode == 5 then
				modes = "NUKE"	
			end
			end
			end
			end
			end				
	end
end
end

function ChangeMode()

    local body = GetPlayerGrabBody()
	local shape = GetPlayerGrabShape()

    if GetString("game.player.tool") == "Trench" and InputDown("mmb") and shape == 0 and body == 0 and reloading == 0 then
	    if mode <= 4 and ModeWait < 0 then
		    mode = mode + 1
			ModeWait = .3
		elseif mode > 4 and ModeWait < 0 then
            mode = 0
			ModeWait = .3
        end			
	end
end

function reload()
	if InputDown("r") and reloading == 0 and magammo < 6 then
	    if magammo == 0 then
			needclose = 1 
			needpull = 1
			relfromzero = 1
		end 
	    reloading = 1
		relTime = 2
		PlaySound(gunRel)
	end
	
	if relTime < 0 and  reloading == 1 then
	    
		if magammo < 6 then
			magammo = 6
			if needpull == 0 and needclose == 0 then
				needclose = 0 
				needpull = 0
			end
        end	
        reloading = 0	
	end
end

function pumpAction()

    local body = GetPlayerGrabBody()
	local shape = GetPlayerGrabShape()

	if InputDown("rmb") and reloading == 0 and shape == 0 and body == 0 and needpull == 0 then
		else if InputDown("rmb") and not InputDown("lmb") and needpull == 1 then
			needpull = 2
			if opensound == 0 then
				PlaySound(gunBoltopen)
				if relfromzero == 1 then
					relfromzero = 0
				else
					PlaySound(shellSnd)
				end	
				opensound = 1
			end
		end
		
		if InputDown("rmb") and needclose == 2 and reloading == 0 and shape == 0 and body == 0 then
			needclose = 3
			needpull = 3		
		end
			
    end
end